<template>
  <FunctionPage header-text-i18n-id="distribute.available.header">
    <v-container>
      <v-row v-if="certificates.results.length === 0">
        <v-col>
          <v-card>
            <v-card-text class="text-center">
              <div v-if="!certificates.loading" class="text-h6 font-italic font-weight-light ma-auto">
                {{ $t("distribute.available.noResults") }}
              </div>
              <v-progress-circular v-if="certificates.loading" indeterminate />
            </v-card-text>
          </v-card>
        </v-col>
      </v-row>
      <v-row v-else>
        <v-col v-for="item in certificates.results" :key="item.id" class="d-flex" style="flex-basis: 320px">
          <v-card class="flex-grow-1 d-flex flex-column pa-2 text-center">
            <v-card-title>
              <icon-with-text icon="certificate" size="small" class="justify-center">
                {{ item.filename }}
              </icon-with-text>
            </v-card-title>
            <v-card-subtitle class="font-weight-bold pb-2" style="font-size: 16px">
              {{
                $t("distribute.available.createdAt", {
                  localeString: item.createdAt.toLocaleString(),
                })
              }}
            </v-card-subtitle>
            <v-card-actions class="ma-auto">
              <!-- TODO implement details button using JS p12 parser -->
              <!--              <v-btn color="secondary" variant="flat" class="px-4" @click="openMoreDetails()">-->
              <!--                <v-icon icon="fas fa-circle-info" class="pr-2" />{{ $t("createIdent.search.result.moreDetailsButton") }}-->
              <!--              </v-btn>-->
              <v-btn color="primary" variant="flat" class="px-4" @click="install(item)">
                <icon-with-text icon="download">{{ $t("distribute.available.download") }}</icon-with-text>
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </FunctionPage>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { requestBackend, requestBackendWithResponseHeaders, store } from "@/ts/common";
import { APIError, APIErrorDialogData } from "@/ts/errorTypes";
import FunctionPage from "@/components/FunctionPage.vue";
import IconWithText from "@/components/IconWithText.vue";
import { PKCS12, PKCS12Type } from "@/ts/types";

type DistributeData = {
  certificates: {
    loading: boolean;
    results: Array<PKCS12>;
    error: APIError | null;
  };
};

export default defineComponent({
  components: { IconWithText, FunctionPage },
  setup() {
    return {
      store,
    };
  },
  data(): DistributeData {
    return {
      certificates: {
        loading: true,
        results: [],
        error: null,
      },
    };
  },
  mounted() {
    this.loadCertificates();
  },
  methods: {
    loadCertificates: function () {
      requestBackend<Array<PKCS12Type>>("/vault/pkcs12").then(
        (data) => {
          // This is just a guard for typescript and should never happen
          if (!this.store.user) {
            return;
          }

          this.certificates.results = data.map((entry) => new PKCS12(entry));
          this.certificates.loading = false;
        },
        (error: APIError) => {
          this.certificates.results = [];
          this.certificates.error = error;
          this.certificates.loading = false;
        }
      );
    },
    install: function (item: PKCS12) {
      requestBackendWithResponseHeaders<Blob>(`/vault/pkcs12/${item.id}`, null, true).then(
        (wrappedResponse) => {
          const downloadLink = document.createElement("a");
          downloadLink.href = window.URL.createObjectURL(wrappedResponse.response);
          console.log(downloadLink.href);
          downloadLink.setAttribute("download", item.filename);
          downloadLink.click();
          downloadLink.remove();
        },
        (error: APIError) => {
          this.store.apiErrorDialogData = new APIErrorDialogData("distribute.errors.downloadFailed", error);
        }
      );
    },
  },
});
</script>
